/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class that show the tasks parameters in the Results module.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class InfoTask extends JFrame {

  JPanel contentPane;
  JScrollPane Scl_Agents = new JScrollPane();
  JLabel jLabel1 = new JLabel();
  JList Lst_Agents = new JList();
  JButton But_Assign = new JButton();
  JLabel jLabel2 = new JLabel();
  JTextField Txt_Task = new JTextField();
  JTextField Txt_Duration = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField Txt_Deadline = new JTextField();
  JLabel jLabel4 = new JLabel();
  JTextField Txt_Cost = new JTextField();
  JLabel jLabel5 = new JLabel();
  JTextField Txt_Priority = new JTextField();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JSlider Sld_Dificult = new JSlider();
  JSlider Sld_Specialized = new JSlider();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel10 = new JLabel();
  JLabel jLabel11 = new JLabel();



  /**Construct the frame*/
  public InfoTask(String NomTask, Vector Ags) {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try { jbInit();
          CargaDatos(NomTask, Ags);
        }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Principal.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(221, 481));
    this.setTitle("Tasks");
    contentPane.setPreferredSize(new Dimension(1, 1));
    Scl_Agents.setBounds(new Rectangle(5, 315, 204, 74));
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel1.setText("Assigned Agents:");
    jLabel1.setBounds(new Rectangle(7, 291, 136, 20));

    But_Assign.setText("Ok");
    But_Assign.setBounds(new Rectangle(63, 399, 80, 31));
    But_Assign.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        try {
              But_Assign_mousePressed(e);
            }
        catch ( IOException e1 ) { System.out.println("ERROR " + e1);}
      }
    });

    jLabel2.setBounds(new Rectangle(3, 12, 55, 20));
    jLabel2.setText("Task:");
    jLabel2.setFont(new java.awt.Font("Dialog", 1, 12));
    Txt_Task.setEnabled(false);
    Txt_Task.setFont(new java.awt.Font("SansSerif", 1, 12));
    Txt_Task.setBounds(new Rectangle(3, 33, 203, 21));
    Txt_Duration.setEnabled(false);
    Txt_Duration.setFont(new java.awt.Font("SansSerif", 1, 12));
    Txt_Duration.setBounds(new Rectangle(3, 81, 93, 21));
    jLabel3.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel3.setText("Duration (Days):");
    jLabel3.setBounds(new Rectangle(4, 61, 101, 20));
    Txt_Deadline.setEnabled(false);
    Txt_Deadline.setFont(new java.awt.Font("SansSerif", 1, 12));
    Txt_Deadline.setBounds(new Rectangle(113, 81, 93, 21));
    jLabel4.setBounds(new Rectangle(114, 61, 72, 20));
    jLabel4.setText("Deadline:");
    jLabel4.setFont(new java.awt.Font("Dialog", 1, 12));
    Txt_Cost.setEnabled(false);
    Txt_Cost.setFont(new java.awt.Font("SansSerif", 1, 12));
    Txt_Cost.setBounds(new Rectangle(2, 131, 93, 21));
    jLabel5.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel5.setText("Cost:");
    jLabel5.setBounds(new Rectangle(3, 111, 72, 20));
    Txt_Priority.setEnabled(false);
    Txt_Priority.setFont(new java.awt.Font("SansSerif", 1, 12));
    Txt_Priority.setBounds(new Rectangle(113, 131, 93, 21));
    jLabel6.setBounds(new Rectangle(114, 111, 72, 20));
    jLabel6.setText("Priority:");
    jLabel6.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel7.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel7.setText("Type:");
    jLabel7.setBounds(new Rectangle(2, 216, 72, 20));
    jLabel8.setBounds(new Rectangle(3, 164, 72, 20));
    jLabel8.setText("Difficult:");
    jLabel8.setFont(new java.awt.Font("Dialog", 1, 12));
    Lst_Agents.setEnabled(false);
    Lst_Agents.setFont(new java.awt.Font("Dialog", 1, 12));
    Sld_Dificult.setEnabled(false);
    Sld_Dificult.setToolTipText("Change Value");
    Sld_Dificult.setValue(0);
    Sld_Dificult.setBounds(new Rectangle(3, 185, 206, 24));
    Sld_Specialized.setEnabled(false);
    Sld_Specialized.setToolTipText("Change Value");
    Sld_Specialized.setValue(0);
    Sld_Specialized.setBounds(new Rectangle(2, 239, 208, 24));
    jLabel9.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel9.setText("Low");
    jLabel9.setBounds(new Rectangle(2, 264, 43, 20));
    jLabel10.setBounds(new Rectangle(68, 266, 76, 20));
    jLabel10.setText("Medium");
    jLabel10.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel10.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel10.setHorizontalTextPosition(SwingConstants.LEADING);
    jLabel11.setBounds(new Rectangle(159, 266, 48, 20));
    jLabel11.setText("High");
    jLabel11.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel11.setHorizontalAlignment(SwingConstants.RIGHT);
    contentPane.add(jLabel2, null);
    contentPane.add(Txt_Task, null);
    contentPane.add(jLabel3, null);
    contentPane.add(Txt_Duration, null);
    contentPane.add(Txt_Deadline, null);
    contentPane.add(jLabel4, null);
    contentPane.add(jLabel5, null);
    contentPane.add(Txt_Cost, null);
    contentPane.add(jLabel6, null);
    contentPane.add(Txt_Priority, null);
    contentPane.add(jLabel8, null);
    contentPane.add(Sld_Dificult, null);
    contentPane.add(Sld_Specialized, null);
    contentPane.add(jLabel7, null);
    contentPane.add(jLabel9, null);
    contentPane.add(jLabel10, null);
    contentPane.add(jLabel11, null);
    contentPane.add(But_Assign, null);
    contentPane.add(jLabel1, null);
    contentPane.add(Scl_Agents, null);
    Scl_Agents.getViewport().add(Lst_Agents, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      this.dispose();
  }


  void But_Assign_mousePressed(MouseEvent e) throws IOException {

    this.dispose();
  }

  public void CargaDatos(String Task, Vector AssignAgs) throws IOException, ClassNotFoundException{

   Tarea Ts;
   Vector Tasks, AssigAgents;
   Agentwrk AgAs;
   int i = 0;
   Float Temp2;

     //ObjectInputStream InTasks = new ObjectInputStream(new FileInputStream(Principal.FileTasks));
     Tasks = Principal.getGlobalTasks(); //(Vector)InTasks.readObject();
     //InTasks.close();

     Ts = (Tarea) Tasks.get(i);
     while (!Ts.getName().equals(Task))
       { i++;
         Ts = (Tarea) Tasks.get(i);
       }

     Txt_Task.setText(Task);
     Txt_Duration.setText(Integer.valueOf(Ts.getDuration()).toString());
     Txt_Deadline.setText(Ts.getDeadLine());
     Txt_Cost.setText(Float.valueOf(Ts.getCost()).toString());
     Txt_Priority.setText(Ts.getPriority());
     Sld_Dificult.setValue(Ts.getDifficult());
     Sld_Specialized.setValue(Ts.getType());
     /*if(Ts.getDifficult())
       Txt_Difficult.setText("Complex");
     else
       Txt_Difficult.setText("Not Complex");
     if(Ts.getType())
       Txt_Type.setText("Generic");
     else
       Txt_Type.setText("Specialized");*/
     AssigAgents = (Vector) Ts.MuestraAgentesAsignados();
     for (int j=0; j< AssigAgents.size(); j++)
      { String NomAg = (String) AssigAgents.get(j);
        i=0;
        AgAs = (Agentwrk) AssignAgs.get(i);
        while (!AgAs.getLocalName().equals(NomAg))
         { i++;
           AgAs = (Agentwrk) AssignAgs.get(i);
         }
        AssigAgents.set(j,NomAg + " --> " + AgAs.getType());
      }
      Lst_Agents.setListData(AssigAgents);
  }

}