/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class for construct a conceptual design project from the single
construction of each task involve in the project.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class Tareas extends JFrame {


  int X1;
  int Y1;
  int XR;
  int YR;
  int GlobalTaskIndex = 0;
  Vector Rectangulos = new Vector(1,1);
  Vector Lineas = new Vector(1,1);
  Vector Etiquetas = new Vector(1,1);
  Vector Tasks = new Vector(1, 1);
  Vector Formas = new Vector(1, 1);
  boolean PuntoLinea = false;
  boolean OprimidoTask = false;
  boolean OprimidoLine = false;
  ImageIcon Task = new ImageIcon("img/Task.gif");
  ImageIcon Line = new ImageIcon("img/Line.gif");
  ImageIcon Borra = new ImageIcon("img/Borra.gif");
  JPanel contentPane;
  JScrollPane Scl_Results = new JScrollPane();
  JPanel Pnl_Tareas = new JPanel();
  Cursor Cruz = new Cursor(1);
  Cursor Normal = new Cursor(0);
  Cursor Reloj = new Cursor(3);
  Cursor Anterior;
  JMenuBar Mnu_Bar = new JMenuBar();
  JMenu Mnu_File = new JMenu();
  JMenuItem Mnu_Open = new JMenuItem();
  JMenuItem Mnu_Close = new JMenuItem();
  JMenuItem Mnu_Save = new JMenuItem();
  JMenuItem Mnu_Exit = new JMenuItem();
  JPanel Pnl_Propiedades = new JPanel();
  Border border1;
  Border border2;
  Border border3;
  ButtonGroup Grp_Difficult = new ButtonGroup();
  ButtonGroup Grp_Type = new ButtonGroup();
  JLabel jLabel1 = new JLabel();
  JTextField Txt_NomTarea = new JTextField();
  JTextField Txt_Cost = new JTextField();
  JTextField Txt_Deadline = new JTextField();
  JTextField Txt_Duration = new JTextField();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel2 = new JLabel();
  String[] data = {"NORMAL", "LOW", "HIGH"};
  JComboBox Cmb_Priority = new JComboBox(data);
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JButton But_CrearTarea = new JButton();
  JButton But_CancelarTarea = new JButton();
  JPanel Pnl_Barra = new JPanel();
  JButton But_Task = new JButton();
  JButton But_Borrar = new JButton();
  JButton But_Line = new JButton();
  JLabel jLabel5 = new JLabel();
  JTextField Txt_AppDomain = new JTextField();
  JLabel jLabel9 = new JLabel();
  JTextField Txt_Description = new JTextField();
  JSlider Sld_Dificult = new JSlider();
  JSlider Sld_Specialized = new JSlider();
  JLabel jLabel10 = new JLabel();
  JLabel jLabel11 = new JLabel();
  JLabel jLabel12 = new JLabel();


  /**Construct the frame*/
  public Tareas() {
   try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
      Mnu_Save.setEnabled(false);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Principal.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    border1 = BorderFactory.createEtchedBorder(new Color(255, 255, 240),new Color(134, 134, 117));
    border2 = BorderFactory.createBevelBorder(BevelBorder.RAISED,new Color(240, 217, 205),Color.white,new Color(117, 106, 100),new Color(81, 74, 70));
    border3 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,new Color(240, 217, 205),new Color(81, 74, 70),new Color(117, 106, 100));
    contentPane.setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(938, 508));
    this.setTitle("TEAKS - Project configuration");
    contentPane.setPreferredSize(new Dimension(1, 1));
    Scl_Results.setBounds(new Rectangle(3, 30, 690, 414));
    Pnl_Tareas.setBorder(border1);
    Pnl_Tareas.setBackground(Color.white);
    Pnl_Tareas.setForeground(Color.blue);
    Pnl_Tareas.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        Pnl_Tareas_mousePressed(e);
      }
      public void mouseClicked(MouseEvent e) {
        Pnl_Tareas_mouseClicked(e);
      }
    });
    Mnu_File.setText("File");
    Mnu_Open.setText("Open project file");
    Mnu_Open.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        try {
             Mnu_Open_actionPerformed(e);
            }
        catch ( IOException e1 ) { System.out.println("ERROR AL ABRIR LAS TAREAS " + e1); }
        catch ( ClassNotFoundException e2 ) { System.out.println("ERROR AL ABRIR LAS TAREAS 134" + e2); }
      }
    });

    Mnu_Save.setText("Save project");
    Mnu_Save.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
       try {
            Mnu_Save_actionPerformed(e);
           }
       catch ( IOException e1 ) { System.out.println("ERROR AL GUARDAR LAS TAREAS " + e1);}
      }
    });

    Mnu_Exit.setText("Exit");
    Mnu_Exit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        Mnu_Exit_actionPerformed(e);
      }
    });

    Pnl_Propiedades.setBorder(border1);
    Pnl_Propiedades.setBounds(new Rectangle(695, 30, 237, 412));
    Pnl_Propiedades.setLayout(null);
    jLabel1.setEnabled(false);
    jLabel1.setText("Name:");
    jLabel1.setBounds(new Rectangle(7, 5, 37, 17));
    Txt_NomTarea.setEnabled(false);
    Txt_NomTarea.setBounds(new Rectangle(5, 25, 224, 19));
    Txt_Cost.setEnabled(false);
    Txt_Cost.setBounds(new Rectangle(9, 130, 80, 21));
    Txt_Deadline.setEnabled(false);
    Txt_Deadline.setBounds(new Rectangle(122, 77, 108, 20));
    Txt_Duration.setEnabled(false);
    Txt_Duration.setBounds(new Rectangle(8, 78, 80, 21));
    jLabel8.setEnabled(false);
    jLabel8.setText("Priority");
    jLabel8.setBounds(new Rectangle(122, 111, 79, 17));
    jLabel4.setEnabled(false);
    jLabel4.setText("Cost");
    jLabel4.setBounds(new Rectangle(9, 109, 50, 18));
    jLabel3.setEnabled(false);
    jLabel3.setText("Deadline:");
    jLabel3.setBounds(new Rectangle(120, 59, 69, 16));
    jLabel2.setEnabled(false);
    jLabel2.setText("Duration (Days)");
    jLabel2.setBounds(new Rectangle(6, 56, 104, 19));
    Cmb_Priority.setEnabled(false);
    Cmb_Priority.setBounds(new Rectangle(123, 130, 108, 20));
    jLabel6.setEnabled(false);
    jLabel6.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel6.setText("Difficult");
    jLabel6.setBounds(new Rectangle(10, 259, 53, 17));
    jLabel7.setEnabled(false);
    jLabel7.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel7.setText("Specialized");
    jLabel7.setBounds(new Rectangle(11, 304, 88, 17));
    But_CrearTarea.setEnabled(false);
    But_CrearTarea.setText("Ok");
    But_CrearTarea.setBounds(new Rectangle(150, 378, 82, 30));
    But_CrearTarea.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        But_CrearTarea_mousePressed(e);
      }
    });
    But_CancelarTarea.setEnabled(false);
    But_CancelarTarea.setText("Cancel");
    But_CancelarTarea.setBounds(new Rectangle(68, 378, 82, 30));
    But_CancelarTarea.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        But_CancelarTarea_mousePressed(e);
      }
    });
    Pnl_Barra.setBorder(border1);
    Pnl_Barra.setBounds(new Rectangle(5, 2, 81, 27));
    Pnl_Barra.setLayout(null);
    But_Task.setEnabled(true);
    But_Task.setBorder(border2);
    But_Task.setToolTipText("Put a task");
    But_Task.setBorderPainted(false);
    But_Task.setBorderPainted(false);
    But_Task.setIcon(Task);
    But_Task.setBounds(new Rectangle(3, 2, 24, 22));
    But_Task.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseEntered(MouseEvent e) {
        But_Task_mouseEntered(e);
      }
      public void mouseExited(MouseEvent e) {
        But_Task_mouseExited(e);
      }
      public void mousePressed(MouseEvent e) {
        But_Task_mousePressed(e);
      }
    });
    But_Borrar.setEnabled(true);
    But_Borrar.setIcon(Borra);
    But_Borrar.setToolTipText("Delete all");
    But_Borrar.setBorderPainted(false);
    But_Borrar.setBorderPainted(false);
    But_Borrar.setBorder(border2);
    But_Borrar.setBounds(new Rectangle(50, 2, 23, 22));
    But_Borrar.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseEntered(MouseEvent e) {
        But_Borrar_mouseEntered(e);
      }
      public void mouseExited(MouseEvent e) {
        But_Borrar_mouseExited(e);
      }
      public void mousePressed(MouseEvent e) {
        But_Borrar_mousePressed(e);
      }
    });
    But_Line.setEnabled(true);
    But_Line.setBorder(border2);
    But_Line.setToolTipText("Put a task dependency");
    But_Line.setBorderPainted(false);
    But_Line.setBorderPainted(false);
    But_Line.setIcon(Line);
    But_Line.setBounds(new Rectangle(27, 2, 23, 22));
    But_Line.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseEntered(MouseEvent e) {
        But_Line_mouseEntered(e);
      }
      public void mouseExited(MouseEvent e) {
        But_Line_mouseExited(e);
      }
      public void mousePressed(MouseEvent e) {
        But_Line_mousePressed(e);
      }
    });
    jLabel5.setBounds(new Rectangle(10, 163, 181, 17));
    jLabel5.setText("Application Domain:");
    jLabel5.setEnabled(false);
    Txt_AppDomain.setBounds(new Rectangle(8, 183, 224, 19));
    Txt_AppDomain.setEnabled(false);
    jLabel9.setEnabled(false);
    jLabel9.setText("Description:");
    jLabel9.setBounds(new Rectangle(10, 210, 181, 17));
    Txt_Description.setEnabled(false);
    Txt_Description.setBounds(new Rectangle(9, 230, 224, 19));
    Sld_Dificult.setEnabled(false);
    Sld_Dificult.setToolTipText("Change Value");
    Sld_Dificult.setValue(0);
    Sld_Dificult.setBounds(new Rectangle(7, 276, 224, 24));
    Sld_Specialized.setEnabled(false);
    Sld_Specialized.setToolTipText("Change Value");
    Sld_Specialized.setValue(0);
    Sld_Specialized.setBounds(new Rectangle(8, 322, 225, 24));
    jLabel10.setBounds(new Rectangle(5, 351, 44, 17));
    jLabel10.setText("LOW");
    jLabel10.setEnabled(false);
    jLabel11.setEnabled(false);
    jLabel11.setText("MEDIUM");
    jLabel11.setBounds(new Rectangle(106, 350, 58, 17));
    jLabel12.setBounds(new Rectangle(182, 350, 47, 17));
    jLabel12.setText("HIGH");
    jLabel12.setVerticalAlignment(SwingConstants.CENTER);
    jLabel12.setVerticalTextPosition(SwingConstants.CENTER);
    jLabel12.setEnabled(false);
    jLabel12.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel12.setHorizontalTextPosition(SwingConstants.LEADING);
    Pnl_Propiedades.add(Sld_Specialized, null);
    Pnl_Propiedades.add(jLabel6, null);
    Pnl_Propiedades.add(Sld_Dificult, null);
    Pnl_Propiedades.add(jLabel7, null);
    Pnl_Propiedades.add(jLabel10, null);
    Pnl_Propiedades.add(jLabel11, null);
    Pnl_Propiedades.add(jLabel12, null);
    Pnl_Propiedades.add(Txt_Description, null);
    Pnl_Propiedades.add(Txt_AppDomain, null);
    Pnl_Propiedades.add(jLabel5, null);
    Pnl_Propiedades.add(But_CrearTarea, null);
    Pnl_Propiedades.add(But_CancelarTarea, null);
    Pnl_Propiedades.add(Txt_NomTarea, null);
    Pnl_Propiedades.add(jLabel1, null);
    Pnl_Propiedades.add(jLabel2, null);
    Pnl_Propiedades.add(jLabel3, null);
    Pnl_Propiedades.add(Txt_Duration, null);
    Pnl_Propiedades.add(Txt_Deadline, null);
    Pnl_Propiedades.add(jLabel4, null);
    Pnl_Propiedades.add(Txt_Cost, null);
    Pnl_Propiedades.add(Cmb_Priority, null);
    Pnl_Propiedades.add(jLabel8, null);
    Pnl_Propiedades.add(jLabel9, null);
    Mnu_File.add(Mnu_Open);
    Mnu_File.add(Mnu_Save);
    Mnu_File.addSeparator();
    Mnu_File.add(Mnu_Exit);
    Mnu_Bar.add(Mnu_File);
    contentPane.add(Scl_Results, null);
    contentPane.add(Pnl_Barra, null);
    Pnl_Barra.add(But_Line, null);
    Pnl_Barra.add(But_Task, null);
    Pnl_Barra.add(But_Borrar, null);
    contentPane.add(Pnl_Propiedades, null);
    Scl_Results.getViewport().add(Pnl_Tareas, null);
    this.setJMenuBar(Mnu_Bar);
  } // END jbInit

  public void paint (Graphics g){

    Cuadro c1;
    Linea L1;
    Etiqueta eti;
    Graphics G1;

    super.paint (g);

    G1 = Pnl_Tareas.getGraphics();

   if (Rectangulos.isEmpty() == false)
      {  for (int i = 0; i < Rectangulos.size(); i++)
          { c1 = (Cuadro) Rectangulos.get(i);
            G1.drawRect(c1.X, c1.Y, c1.width, c1.height);
          }
      }
   if (Lineas.isEmpty() == false)
      {  for (int i = 0; i < Lineas.size(); i++)
          { L1 = (Linea) Lineas.get(i);
            G1.drawLine(L1.X1, L1.Y1, L1.X2, L1.Y2);
         }
      }
   if (Etiquetas.isEmpty() == false)
      {  for (int i = 0; i < Etiquetas.size(); i++)
          { eti = (Etiqueta) Etiquetas.get(i);
            G1.setColor(Color.blue);
            G1.drawString(eti.Letrero, eti.EtX, eti.EtY);
            G1.setColor(Color.black);
         }
      }
}  // FIN PAINT




  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      this.dispose();
  }

  public void Mnu_Open_actionPerformed(ActionEvent e) throws IOException, FileNotFoundException, ClassNotFoundException{

    Tarea T;
    Vector Prec, Ant;

      contentPane.setCursor(Reloj);
      JFileChooser chooser = new JFileChooser();
      ExampleFileFilter filter = new ExampleFileFilter();
      filter.addExtension("tsk");
      filter.setDescription("Tasks files");
      chooser.setFileFilter(filter);
      chooser.setCurrentDirectory(new File("\\"));
      int returnVal = chooser.showOpenDialog(null);
      if(returnVal == JFileChooser.APPROVE_OPTION) {
        Tasks.removeAllElements();
        Formas.removeAllElements();
        Rectangulos.removeAllElements();
        Lineas.removeAllElements();
        Etiquetas.removeAllElements();
        String Nombre = chooser.getSelectedFile().getAbsolutePath(); //.getName();
        ObjectInputStream InTasks = new ObjectInputStream(new FileInputStream(chooser.getSelectedFile().getAbsoluteFile()));
        Tasks = (Vector)InTasks.readObject();
        InTasks.close();
        for (int i=0; i < Tasks.size(); i++)
        { T = (Tarea) Tasks.get(i);
          System.out.print(T.getID() + " ");
          System.out.print(T.getX()+ " ");
          System.out.print(T.getY()+ " ");
          System.out.print(T.getName()+ " ");
          System.out.print(T.getDuration()+ " ");
          System.out.print(T.getDeadLine() + " ");
          System.out.print(T.getCost() + " ");
          System.out.print(T.getAppDomain() + " ");
          System.out.print(T.getDescription() + " ");
          System.out.print(T.getPriority() + " ");
          System.out.print(T.getDifficult() + " ");
          System.out.println(T.getType());
       }
       for (int i=0; i < Tasks.size(); i++)  //ESTO ES PARA VER LAS PRECEDENCIAS *********
       { T = (Tarea) Tasks.get(i);
         Prec = T.MuestraPrecedencias();
         for (int k=0; k < Prec.size(); k++)
           System.out.println(T.getName() + " es precedente a " + Prec.get(k).toString());
         Ant = T.MuestraAnteriores();
         for (int k=0; k < Ant.size(); k++)
           System.out.println(T.getName() + " es la siguiente de " + Ant.get(k).toString());
       }

       ObjectInputStream InForms = new ObjectInputStream(new FileInputStream(Nombre.substring(0,Nombre.indexOf(".")) + ".frm"));
       Formas = (Vector)InForms.readObject();
       InForms.close();
       Rectangulos = (Vector)Formas.get(0);
       Lineas = (Vector)Formas.get(1);
       Etiquetas = (Vector)Formas.get(2);
       repaint();
     }
    contentPane.setCursor(Normal);
  }

  public void Mnu_Save_actionPerformed(ActionEvent e) throws IOException{

   Tarea T;

     contentPane.setCursor(Reloj);

      for (int i=0; i < Tasks.size(); i++)  //ESTO ES PARA VER LAS PRECEDENCIAS *********
       { T = (Tarea) Tasks.get(i);
         T.RemoveAllPrecedencias();
         T.RemoveAllAnteriores();
       }

    JFileChooser chooser = new JFileChooser();
    ExampleFileFilter filter = new ExampleFileFilter();
    filter.addExtension("tsk");
    filter.setDescription("Tasks files");
    chooser.setFileFilter(filter);
    chooser.setCurrentDirectory(new File("\\"));
    int returnVal = chooser.showSaveDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      String Nombre = chooser.getSelectedFile().getName();
      ObjectOutputStream OutTasks = new ObjectOutputStream(new FileOutputStream(Nombre));
      ObjectOutputStream OutForms = new ObjectOutputStream(new FileOutputStream(Nombre.substring(0,Nombre.indexOf(".")) + ".frm"));

      AsignaPrecedencias();
      AsignaAntecedencias();
      Formas.addElement(Rectangulos);
      Formas.addElement(Lineas);
      Formas.addElement(Etiquetas);

      OutTasks.writeObject(Tasks);
      OutTasks.close();
      OutForms.writeObject(Formas);
      OutForms.close();

      But_Line.setBorder(border2);
      But_Task.setBorder(border2);
      But_Line.setBorderPainted(false);
      But_Task.setBorderPainted(false);
      OprimidoLine = false;
      OprimidoTask = false;
      contentPane.setCursor(Normal);
      Anterior = contentPane.getCursor();
    }
  Principal.contentPane.setCursor(Normal);
  }

 public void Mnu_Exit_actionPerformed(ActionEvent e){

    this.dispose();
 }

   boolean Coincide(int Cx, int Cy){

   Cuadro c2;
   int X2, Y2;
   boolean resultado = false;

    for (int i = 0; i < Rectangulos.size(); i++)
      { c2 = (Cuadro) Rectangulos.get(i);
        X2 = c2.X + c2.width;
        Y2 = c2.Y + c2.height;
        if ((Cx >= c2.X) && (Cx <= X2) && (Cy >= c2.Y) && (Cy <= Y2))
           resultado = true;
      }
    return resultado;
  }

  void Deshabilitar() {

     jLabel1.setEnabled(false);
     Txt_NomTarea.setEnabled(false);
     jLabel2.setEnabled(false);
     Txt_Duration.setEnabled(false);
     jLabel3.setEnabled(false);
     Txt_Deadline.setEnabled(false);
     jLabel4.setEnabled(false);
     Txt_Cost.setEnabled(false);
     jLabel6.setEnabled(false);
     jLabel7.setEnabled(false);
     jLabel8.setEnabled(false);
     jLabel5.setEnabled(false);
     jLabel9.setEnabled(false);
     jLabel10.setEnabled(false);
     jLabel11.setEnabled(false);
     jLabel12.setEnabled(false);
     Cmb_Priority.setEnabled(false);
     Txt_AppDomain.setEnabled(false);
     Txt_Description.setEnabled(false);
     But_CrearTarea.setEnabled(false);
     But_CancelarTarea.setEnabled(false);
     Sld_Specialized.setEnabled(false);
     Sld_Dificult.setEnabled(false);
  }

  void Habilitar() {

     jLabel1.setEnabled(true);
     Txt_NomTarea.setEnabled(true);
     jLabel2.setEnabled(true);
     Txt_Duration.setEnabled(true);
     jLabel3.setEnabled(true);
     Txt_Deadline.setEnabled(true);
     jLabel4.setEnabled(true);
     Txt_Cost.setEnabled(true);
     jLabel5.setEnabled(true);
     jLabel6.setEnabled(true);
     jLabel7.setEnabled(true);
     jLabel8.setEnabled(true);
     jLabel9.setEnabled(true);
     jLabel10.setEnabled(true);
     jLabel11.setEnabled(true);
     jLabel12.setEnabled(true);
     Txt_AppDomain.setEnabled(true);
     Txt_Description.setEnabled(true);
     Cmb_Priority.setEnabled(true);
     Sld_Specialized.setEnabled(true);
     Sld_Dificult.setEnabled(true);
     But_CrearTarea.setEnabled(true);
     But_CancelarTarea.setEnabled(true);
     Txt_NomTarea.requestFocus();
  }

   void AsignaPrecedencias(){

    Linea lin;
    int IdT = 0;
    int IdTP = 0;
    int j;
    int indice1 = 0 , indice2 = 0;
    Tarea T, T1, T2;
    Vector Prec;


      for (int i = 0; i < Lineas.size(); i++)
      { lin = (Linea) Lineas.get(i);
        j = 0;
        while (IdT == 0)
           {T = (Tarea) Tasks.get(j);
            IdT = T.WhatTaskIs(lin.X1, lin.Y1);
            indice1 = j;
            j++;
           }
        j = 0;
        while (IdTP == 0)
           {T = (Tarea) Tasks.get(j);
            IdTP = T.WhatTaskIs(lin.X2, lin.Y2);
            indice2 = j;
            j++;
           }
        T1 = (Tarea) Tasks.get(indice1);
        T2 = (Tarea) Tasks.get(indice2);
        if (lin.X1 < lin.X2)
           T1.AsignaPrecedencia(T2.getID());
        else
           T2.AsignaPrecedencia(T1.getID());
        IdT = 0;
        IdTP = 0;
      }
  }


  void AsignaAntecedencias(){

    Tarea T, T2;
    Vector Prec, Ant;
    int index;
    Integer IdTS = new Integer(0);

    for (int i = 0; i<Tasks.size(); i++)
     {T = (Tarea) Tasks.get(i);
      Prec = (Vector) T.MuestraPrecedencias();
      for (int j = 0; j<Prec.size(); j++)
       { IdTS = (Integer) Prec.get(j);
         index = 0;
         T2 = (Tarea) Tasks.get(index);
         while (IdTS.intValue() != T2.getID())
           { index ++;
             T2 = (Tarea) Tasks.get(index);
           }
         T2.AsignaAnterior(T.getID());
       }
    }

}

  void But_Task_mouseEntered(MouseEvent e) {
   if (But_Task.isEnabled() == true)
    if((OprimidoTask == false) && (OprimidoLine == false))
      { But_Task.setBorderPainted(true);
        Anterior = contentPane.getCursor();
        contentPane.setCursor(Normal);
      }
  }

  void But_Task_mouseExited(MouseEvent e) {
   if (But_Task.isEnabled() == true)
    if((OprimidoTask == false) && (OprimidoLine == false))
     { But_Task.setBorderPainted(false);
       contentPane.setCursor(Anterior);
     }
  }

  void But_Task_mousePressed(MouseEvent e) {

   if (But_Task.isEnabled() == true)
     if(OprimidoTask == false)
      { But_Task.setBorder(border3);
        But_Task.setBorderPainted(true);
        But_Line.setBorder(border2);
        But_Line.setBorderPainted(false);
        contentPane.setCursor(Cruz);
        OprimidoTask = true;
        OprimidoLine = false;
      }
     else
      {  But_Task.setBorder(border2);
         But_Task.setBorderPainted(false);
         contentPane.setCursor(Normal);
         OprimidoTask = false;
      }
  }

  void But_Line_mouseEntered(MouseEvent e) {
   if (But_Line.isEnabled() == true)
    if((OprimidoLine == false) && (OprimidoTask == false))
     But_Line.setBorderPainted(true);
  }

  void But_Line_mouseExited(MouseEvent e) {
   if (But_Line.isEnabled() == true)
     if((OprimidoLine == false) && (OprimidoTask == false))
      But_Line.setBorderPainted(false);
  }

  void But_Line_mousePressed(MouseEvent e) {

   if (But_Line.isEnabled() == true)
    if(OprimidoLine == false)
      { But_Line.setBorder(border3);
        But_Line.setBorderPainted(true);
        But_Task.setBorder(border2);
        But_Task.setBorderPainted(false);
        contentPane.setCursor(Cruz);
        OprimidoLine = true;
        OprimidoTask = false;
      }
     else
      { But_Line.setBorder(border2);
        But_Line.setBorderPainted(false);
        contentPane.setCursor(Normal);
        OprimidoLine = false;
      }
  }

  void But_Borrar_mousePressed(MouseEvent e) {

   if (But_Borrar.isEnabled() == true)
    { Pnl_Tareas.repaint();
      But_Line.setBorder(border2);
      But_Task.setBorder(border2);
      But_Line.setBorderPainted(false);
      But_Task.setBorderPainted(false);
      OprimidoLine = false;
      OprimidoTask = false;
      Anterior = Normal;
      Tasks.removeAllElements();
      Rectangulos.removeAllElements();
      Lineas.removeAllElements();
      Etiquetas.removeAllElements();
      Mnu_Save.setEnabled(false);
    }
  }

  void But_Borrar_mouseEntered(MouseEvent e) {

   if (But_Borrar.isEnabled() == true)
    { But_Borrar.setBorderPainted(true);
      Anterior = contentPane.getCursor();
      contentPane.setCursor(Normal);
    }
  }

  void But_Borrar_mouseExited(MouseEvent e) {

   if (But_Borrar.isEnabled() == true)
     { But_Borrar.setBorderPainted(false);
       contentPane.setCursor(Anterior);
     }
  }

  void Pnl_Tareas_mousePressed(MouseEvent e) {
    Graphics Line = Pnl_Tareas.getGraphics();
    Graphics Cuad = Pnl_Tareas.getGraphics();

      if (OprimidoTask == true)
        {Cuadro c = new Cuadro();
         Cuad.drawRect(e.getX(), e.getY(), 40, 15);
         c.X = e.getX();
         c.Y = e.getY();
         Rectangulos.addElement(c);
         XR = e.getX();
         YR = e.getY();
         Habilitar();
         OprimidoTask = false;
         But_Task.setBorder(border2);
         But_Task.setBorderPainted(false);
         contentPane.setCursor(Normal);
        }
     else
        if (OprimidoLine == true)
          if(PuntoLinea == false)
            { X1 = e.getX();
              Y1 = e.getY();
              PuntoLinea = true;
            }
           else
            { Linea L = new Linea();
              L.X1 = X1;
              L.Y1 = Y1;
              L.X2 = e.getX();
              L.Y2 = e.getY();
              if (Coincide(L.X1, L.Y1) && Coincide(L.X2, L.Y2))
                {
                 Line.drawLine(L.X1, L.Y1, L.X2, L.Y2);
                 Lineas.addElement(L);
                }
              PuntoLinea = false;
              But_Borrar.requestFocus();
            }
       Mnu_Save.setEnabled(true);
  }

  void But_CrearTarea_mousePressed(MouseEvent e) {
  //  ********* AQUI SE CREA O MODIFICA LA TAREA *********

    Etiqueta E = new Etiqueta();
    Graphics Let = Pnl_Tareas.getGraphics();

    if (But_CrearTarea.getText() == "Modify")
      { System.out.println(GlobalTaskIndex);
        if (Tasks.size() > 0 && GlobalTaskIndex >= 0)
         { Tarea TM = (Tarea) Tasks.get(GlobalTaskIndex);
           E = (Etiqueta) Etiquetas.get(GlobalTaskIndex);
           E.Letrero = Txt_NomTarea.getText();
           TM.setName(Txt_NomTarea.getText());
           Integer Dias = new Integer(Txt_Duration.getText());
           int Dur = Dias.intValue();
           TM.setDuration(Dur);
           TM.setDeadLine(Txt_Deadline.getText());
           Float Ct = new Float(Txt_Cost.getText());
           float Cos = Ct.floatValue();
           TM.setCost(Cos);
           TM.setPriority(Cmb_Priority.getSelectedItem().toString());
           TM.setAppDomain(Txt_AppDomain.getText());
           TM.setDescription(Txt_Description.getText());
           TM.setDifficult(Sld_Dificult.getValue());
           TM.setType(Sld_Specialized.getValue());
           Etiquetas.setElementAt(E, GlobalTaskIndex);
           Tasks.setElementAt(TM, GlobalTaskIndex);
           GlobalTaskIndex = 0;
           But_CrearTarea.setText("Ok");
           repaint();
         }
      }
    else
      { Tarea T = new Tarea(XR, YR);
        T.setID(Tasks.size() + 1);
        T.setName(Txt_NomTarea.getText());
        Integer Dias = new Integer(Txt_Duration.getText());
        int Dur = Dias.intValue();
        T.setDuration(Dur);
        T.setDeadLine(Txt_Deadline.getText());
        Float Ct = new Float(Txt_Cost.getText());
        float Cos = Ct.floatValue();
        T.setCost(Cos);
        T.setPriority(Cmb_Priority.getSelectedItem().toString());
        T.setAppDomain(Txt_AppDomain.getText());
        T.setDescription(Txt_Description.getText());
        T.setDifficult(Sld_Dificult.getValue());
        T.setType(Sld_Specialized.getValue());
        Tasks.addElement(T);
        Let.setColor(Color.blue);
        Let.drawString(Txt_NomTarea.getText(), XR - 10, YR - 5);
        Let.setColor(Color.black);
        E.EtX = XR - 10;
        E.EtY = YR - 5;
        E.Letrero = Txt_NomTarea.getText();
        Etiquetas.addElement(E);
      }
    Txt_NomTarea.setText("");
    Txt_Duration.setText("");
    Txt_Deadline.setText("");
    Txt_Cost.setText("");
    Txt_AppDomain.setText("");
    Txt_Description.setText("");
    Cmb_Priority.setSelectedItem("NORMAL");
    Sld_Specialized.setValue(0);
    Sld_Dificult.setValue(0);
    Deshabilitar();
    But_Borrar.requestFocus();
  }

  void But_CancelarTarea_mousePressed(MouseEvent e) {

    Graphics Cuad = Pnl_Tareas.getGraphics();

    Txt_NomTarea.setText("");
    Txt_Duration.setText("");
    Txt_Deadline.setText("");
    Txt_Cost.setText("");
    Txt_AppDomain.setText("");
    Txt_Description.setText("");
    Cmb_Priority.setSelectedItem("NORMAL");
    Sld_Specialized.setValue(0);
    Sld_Dificult.setValue(0);
    if (But_CrearTarea.getText() == "Ok")
     { Cuad.setColor(Color.white);
       Cuad.drawRect(XR, YR, 40, 15);
       Cuad.setColor(Color.black);
       Rectangulos.removeElementAt(Rectangulos.size()-1);
     }
    Deshabilitar();
  }

  void Pnl_Tareas_mouseClicked(MouseEvent e) {

    int indice1 = 0, j, IdT = 0;
    int TDur;
    float TCost;
    Tarea T;

     if (e.getClickCount() == 2)
       { if (Tasks.size() > 0)
          {  j = 0;
             while (IdT == 0)
             { T = (Tarea) Tasks.get(j);
               IdT = T.WhatTaskIs(e.getX(), e.getY());
               indice1 = j;
               j++;
             }
             T = (Tarea) Tasks.get(indice1);
             Habilitar();
             Txt_NomTarea.setText(T.getName());
             TDur = T.getDuration();
             Integer Dias = new Integer(TDur);
             Txt_Duration.setText(Dias.toString());
             Txt_Deadline.setText(T.getDeadLine());
             TCost = T.getCost();
             Float Costo = new Float(TCost);
             Txt_Cost.setText(Costo.toString());
             Txt_AppDomain.setText(T.getAppDomain());
             Txt_Description.setText(T.getDescription());
             Cmb_Priority.setSelectedItem(T.getPriority());
             Sld_Dificult.setValue(T.getDifficult());
             Sld_Specialized.setValue(T.getType());
             But_CrearTarea.setText("Modify");
             GlobalTaskIndex = indice1;
          }
       }
  }

}