/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class for configuring the parameters for execute the simulations.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class Configure extends JFrame {

  /*public static int Desire = 30;
  public static int Interest = 40;
  public static int Disgust = 20;
  public static int Anxiety = 40;
  public static int Creativity = 30;
  public static int Experience = 50;
  public static int Stress = 60;*/
  public static int Sv = 10;
  public static boolean includeTrustModel = false;
  public static double initialTrustLevel = 25.0;

  Relations ObjRelations = null;
  JPanel contentPane;
  TitledBorder titledBorder1;
  JLabel jLabel1 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JCheckBox Chk_TrustModel = new JCheckBox("Include Trust Model");
  JTextField Txt_Sv = new JTextField();
  JLabel jLabel9 = new JLabel();
  JButton But_Assign = new JButton();
  JLabel jLabel10 = new JLabel();
  JLabel jLabel11 = new JLabel();
  JLabel jLabel12 = new JLabel();
  String[] DurCreat = {"High_Advance", "Medium_Advance", "Normal", "Medium_Delay", "High_Delay"};
  String[] QtyCreat = {"High_Decrease", "Medium_Decrease", "Normal", "Medium_Increase", "High_Increase"};
  String[] TrustLevel = {"Low", "Medium", "High"};
  JComboBox Cmb_TrustLevel = new JComboBox(TrustLevel);
  JComboBox Cmb_TskDurLowCreat = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyLowCreat = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurMedCreat = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyMedCreat = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurHghCreat = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyHghCreat = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurLowExp = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyLowExp = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurMedExp = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyMedExp = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurHghExp = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyHghExp = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurLowDsr = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyLowDsr = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurMedDsr = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyMedDsr = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurHghDsr = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyHghDsr = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurLowInt = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyLowInt = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurMedInt = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyMedInt = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurHghInt = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyHghInt = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurLowDis = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyLowDis = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurMedDis = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyMedDis = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurHghDis = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyHghDis = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurLowAnx = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyLowAnx = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurMedAnx = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyMedAnx = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurHghAnx = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyHghAnx = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurLowStrs = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyLowStrs = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurMedStrs = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyMedStrs = new JComboBox(QtyCreat);
  JComboBox Cmb_TskDurHghStrs = new JComboBox(DurCreat);
  JComboBox Cmb_TskQtyHghStrs = new JComboBox(QtyCreat);
  JLabel jLabel13 = new JLabel();
  JLabel jLabel14 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JScrollPane Scrl_Weight = new JScrollPane();
  JTextPane jTextPane1 = new JTextPane();
  JLabel jLabel15 = new JLabel();
  JLabel jLabel16 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel17 = new JLabel();
  JLabel jLabel18 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel19 = new JLabel();
  JLabel jLabel110 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel111 = new JLabel();
  JLabel jLabel112 = new JLabel();
  JLabel jLabel20 = new JLabel();
  JLabel jLabel113 = new JLabel();
  JLabel jLabel114 = new JLabel();
  JLabel jLabel21 = new JLabel();
  JButton But_Defaults = new JButton();
  JPanel Pnl_Trust = new JPanel();


  /**Construct the frame*/
  public Configure() {
   try {
      jbInit();
      Carga_Datos();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Principal.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    titledBorder1 = new TitledBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED,Color.black,Color.white,Color.white,Color.black),"");
    contentPane.setLayout(null);
    this.setResizable(false);
    //this.setSize(new Dimension(541, 441));
    this.setSize(new Dimension(341, 221));
    this.setTitle("Parameters configuration");
    contentPane.setPreferredSize(new Dimension(1, 1));
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel1.setForeground(new Color(112, 0, 0));
    jLabel1.setText("TRUST PARAMETERS");
    jLabel1.setBounds(new Rectangle(10, 50, 140, 20));
    jLabel3.setText("Initial trust level in agents:");
    jLabel3.setBounds(new Rectangle(12, 35, 200, 17));
    if (!includeTrustModel)
    	jLabel3.setEnabled(false);
    jLabel8.setBounds(new Rectangle(186, 47, 106, 17));
    jLabel8.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel8.setText("TASK  DURATION");
    Chk_TrustModel.setBounds(new Rectangle(12, 5, 140, 20));
    Chk_TrustModel.setSelected(includeTrustModel);
    Chk_TrustModel.addItemListener(new java.awt.event.ItemListener(){
    	public void itemStateChanged(ItemEvent e) {
    		if (e.getStateChange() == ItemEvent.DESELECTED){
    			jLabel3.setEnabled(false);
    			Cmb_TrustLevel.setEnabled(false);
    			Cmb_TrustLevel.setSelectedIndex(1);
    		}
    		else{
    			Cmb_TrustLevel.setEnabled(true);
    			jLabel3.setEnabled(true);
    		}
    	}
    });
    
    Txt_Sv.setBounds(new Rectangle(275, 20, 40, 18));
    jLabel9.setText("Standard deviation used during randomness:");
    jLabel9.setBounds(new Rectangle(10, 20, 270, 17));
    Cmb_TrustLevel.setBounds(new Rectangle(165, 35, 95, 18));
    if (initialTrustLevel == 0.0)
		Cmb_TrustLevel.setSelectedIndex(0);
	else if (initialTrustLevel == 25.0)
		Cmb_TrustLevel.setSelectedIndex(1);
	else if (initialTrustLevel == 50.0)
		Cmb_TrustLevel.setSelectedIndex(2);
    if (!includeTrustModel){
    	Cmb_TrustLevel.setSelectedIndex(1);
    	Cmb_TrustLevel.setEnabled(false);
    }

    Pnl_Trust.setBorder(BorderFactory.createEtchedBorder());
    Pnl_Trust.setBounds(new Rectangle(8, 70, 310, 70));
    Pnl_Trust.setLayout(null);
    Pnl_Trust.add(Chk_TrustModel, null);
    Pnl_Trust.add(Cmb_TrustLevel, null);
    Pnl_Trust.add(jLabel3, null);
    
    //jLabel9.setBounds(new Rectangle(18, 348, 112, 17));
    But_Assign.setText("Ok");
    But_Assign.setBounds(new Rectangle(120, 150, 80, 31));
    But_Assign.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        try {
              But_Assign_mousePressed(e);
            }
        catch ( IOException e1 ) { System.out.println("ERROR EN CONFIGURE 150" + e1);}
      }
    });

    jLabel10.setBounds(new Rectangle(8, 33, 138, 17));
    jLabel10.setText("Medium Creativity:");
    jLabel11.setBounds(new Rectangle(9, 54, 87, 17));
    jLabel11.setText("High Creativity:");
    jLabel12.setText("TASK   QUALITY");
    jLabel12.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel12.setBounds(new Rectangle(367, 48, 106, 17));
    Cmb_TskDurLowCreat.setBounds(new Rectangle(144, 8, 145, 18));
    Cmb_TskQtyLowCreat.setBounds(new Rectangle(319, 8, 145, 18));
    Cmb_TskDurMedCreat.setBounds(new Rectangle(144, 32, 145, 18));
    Cmb_TskQtyMedCreat.setBounds(new Rectangle(319, 32, 145, 18));
    Cmb_TskDurHghCreat.setBounds(new Rectangle(144, 55, 145, 18));
    Cmb_TskQtyHghCreat.setBounds(new Rectangle(319, 55, 145, 18));
    Cmb_TskDurHghExp.setBounds(new Rectangle(144, 139, 145, 18));
    Cmb_TskQtyMedExp.setBounds(new Rectangle(319, 116, 145, 18));
    jLabel13.setText("High Experience:");
    jLabel13.setBounds(new Rectangle(9, 138, 107, 17));
    jLabel14.setText("Medium Experience:");
    jLabel14.setBounds(new Rectangle(8, 117, 138, 17));
    Cmb_TskDurLowExp.setBounds(new Rectangle(144, 92, 145, 18));
    Cmb_TskQtyHghExp.setBounds(new Rectangle(319, 139, 145, 18));
    Cmb_TskQtyLowExp.setBounds(new Rectangle(319, 92, 145, 18));
    jLabel4.setBounds(new Rectangle(9, 96, 102, 17));
    jLabel4.setText("Low Experience:");
    Cmb_TskDurMedExp.setBounds(new Rectangle(144, 116, 145, 18));
    Scrl_Weight.setBounds(new Rectangle(18, 67, 489, 260));
    jTextPane1.setBorder(BorderFactory.createEtchedBorder());
    jTextPane1.setEditable(false);
    jTextPane1.setFont(new java.awt.Font("Serif", 0, 460));
    jTextPane1.setBackground(UIManager.getColor("Button.background"));
    jTextPane1.setLayout(null);
    Cmb_TskQtyMedDsr.setBounds(new Rectangle(317, 201, 145, 18));
    jLabel15.setBounds(new Rectangle(6, 202, 138, 17));
    jLabel15.setText("Medium Desire:");
    Cmb_TskDurHghDsr.setBounds(new Rectangle(142, 224, 145, 18));
    Cmb_TskQtyLowDsr.setBounds(new Rectangle(317, 177, 145, 18));
    jLabel16.setBounds(new Rectangle(7, 223, 107, 17));
    jLabel16.setText("High Desire:");
    Cmb_TskDurMedDsr.setBounds(new Rectangle(142, 200, 145, 18));
    Cmb_TskDurLowDsr.setBounds(new Rectangle(142, 177, 145, 18));
    Cmb_TskQtyHghDsr.setBounds(new Rectangle(317, 224, 145, 18));
    jLabel5.setText("Low Desire:");
    jLabel5.setBounds(new Rectangle(7, 181, 102, 17));
    Cmb_TskQtyMedInt.setBounds(new Rectangle(316, 283, 145, 18));
    jLabel17.setBounds(new Rectangle(5, 284, 138, 17));
    jLabel17.setText("Medium Interest:");
    Cmb_TskDurHghInt.setBounds(new Rectangle(141, 306, 145, 18));
    Cmb_TskQtyLowInt.setBounds(new Rectangle(316, 259, 145, 18));
    jLabel18.setBounds(new Rectangle(6, 305, 107, 17));
    jLabel18.setText("High Interest:");
    Cmb_TskDurMedInt.setBounds(new Rectangle(141, 283, 145, 18));
    Cmb_TskDurLowInt.setBounds(new Rectangle(141, 259, 145, 18));
    Cmb_TskQtyHghInt.setBounds(new Rectangle(316, 306, 145, 18));
    jLabel6.setText("Low Interest:");
    jLabel6.setBounds(new Rectangle(6, 263, 102, 17));
    Cmb_TskQtyMedDis.setBounds(new Rectangle(315, 365, 145, 18));
    jLabel19.setBounds(new Rectangle(6, 367, 111, 17));
    jLabel19.setText("Medium Disgust:");
    Cmb_TskDurHghDis.setBounds(new Rectangle(140, 388, 145, 18));
    Cmb_TskQtyLowDis.setBounds(new Rectangle(315, 341, 145, 18));
    jLabel110.setBounds(new Rectangle(7, 388, 107, 17));
    jLabel110.setText("High Disgust:");
    Cmb_TskDurMedDis.setBounds(new Rectangle(140, 365, 145, 18));
    Cmb_TskDurLowDis.setBounds(new Rectangle(140, 341, 145, 18));
    Cmb_TskQtyHghDis.setBounds(new Rectangle(315, 388, 145, 18));
    jLabel7.setText("Low Disgust:");
    jLabel7.setBounds(new Rectangle(7, 346, 102, 17));
    Cmb_TskQtyMedAnx.setBounds(new Rectangle(313, 449, 145, 18));
    jLabel111.setBounds(new Rectangle(6, 450, 111, 17));
    jLabel111.setText("Medium Anxiety:");
    Cmb_TskDurHghAnx.setBounds(new Rectangle(138, 472, 145, 18));
    Cmb_TskQtyLowAnx.setBounds(new Rectangle(313, 425, 145, 18));
    jLabel112.setBounds(new Rectangle(7, 471, 107, 17));
    jLabel112.setText("High Anxiety:");
    Cmb_TskDurMedAnx.setBounds(new Rectangle(138, 449, 145, 18));
    Cmb_TskDurLowAnx.setBounds(new Rectangle(138, 425, 145, 18));
    Cmb_TskQtyHghAnx.setBounds(new Rectangle(313, 472, 145, 18));
    jLabel20.setText("Low Anxiety:");
    jLabel20.setBounds(new Rectangle(7, 429, 102, 17));
    Cmb_TskQtyMedStrs.setBounds(new Rectangle(312, 532, 145, 18));
    jLabel113.setBounds(new Rectangle(5, 533, 109, 17));
    jLabel113.setText("Medium Stress:");
    Cmb_TskDurHghStrs.setBounds(new Rectangle(137, 555, 145, 18));
    Cmb_TskQtyLowStrs.setBounds(new Rectangle(312, 508, 145, 18));
    jLabel114.setBounds(new Rectangle(6, 554, 89, 17));
    jLabel114.setText("High Stress:");
    Cmb_TskDurMedStrs.setBounds(new Rectangle(137, 532, 145, 18));
    Cmb_TskDurLowStrs.setBounds(new Rectangle(137, 508, 145, 18));
    Cmb_TskQtyHghStrs.setBounds(new Rectangle(312, 555, 145, 18));
    jLabel21.setText("Low Stress:");
    jLabel21.setBounds(new Rectangle(6, 512, 90, 17));
    But_Defaults.setText("Default Values");
    But_Defaults.setBounds(new Rectangle(372, 328, 135, 31));
    But_Defaults.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        But_Defaults_mousePressed(e);
      }
    });
    contentPane.add(jLabel1, null);
    /*contentPane.add(Scrl_Weight, null);
    Scrl_Weight.getViewport().add(jTextPane1, null);
    jTextPane1.add(Cmb_TskQtyHghExp, null);
    jTextPane1.add(jLabel3, null);
    jTextPane1.add(jLabel10, null);
    jTextPane1.add(jLabel11, null);
    jTextPane1.add(jLabel4, null);
    jTextPane1.add(jLabel14, null);
    jTextPane1.add(jLabel13, null);
    jTextPane1.add(Cmb_TskDurLowCreat, null);
    jTextPane1.add(Cmb_TskDurMedCreat, null);
    jTextPane1.add(Cmb_TskDurHghCreat, null);
    jTextPane1.add(Cmb_TskDurLowExp, null);
    jTextPane1.add(Cmb_TskDurMedExp, null);
    jTextPane1.add(Cmb_TskDurHghExp, null);
    jTextPane1.add(Cmb_TskQtyMedExp, null);
    jTextPane1.add(Cmb_TskQtyLowExp, null);
    jTextPane1.add(Cmb_TskQtyHghCreat, null);
    jTextPane1.add(Cmb_TskQtyMedCreat, null);
    jTextPane1.add(Cmb_TskQtyLowCreat, null);
    jTextPane1.add(Cmb_TskQtyHghDsr, null);
    jTextPane1.add(jLabel5, null);
    jTextPane1.add(jLabel15, null);
    jTextPane1.add(jLabel16, null);
    jTextPane1.add(Cmb_TskDurLowDsr, null);
    jTextPane1.add(Cmb_TskDurMedDsr, null);
    jTextPane1.add(Cmb_TskDurHghDsr, null);
    jTextPane1.add(Cmb_TskQtyMedDsr, null);
    jTextPane1.add(Cmb_TskQtyLowDsr, null);
    jTextPane1.add(Cmb_TskQtyHghInt, null);
    jTextPane1.add(jLabel6, null);
    jTextPane1.add(jLabel17, null);
    jTextPane1.add(jLabel18, null);
    jTextPane1.add(Cmb_TskDurHghInt, null);
    jTextPane1.add(Cmb_TskDurLowInt, null);
    jTextPane1.add(Cmb_TskDurMedInt, null);
    jTextPane1.add(Cmb_TskQtyLowInt, null);
    jTextPane1.add(Cmb_TskQtyMedInt, null);
    jTextPane1.add(Cmb_TskDurHghDis, null);
    jTextPane1.add(Cmb_TskQtyMedDis, null);
    jTextPane1.add(Cmb_TskQtyLowDis, null);
    jTextPane1.add(Cmb_TskQtyHghDis, null);
    jTextPane1.add(Cmb_TskDurMedDis, null);
    jTextPane1.add(Cmb_TskDurLowDis, null);
    jTextPane1.add(Cmb_TskQtyHghAnx, null);
    jTextPane1.add(Cmb_TskDurHghAnx, null);
    jTextPane1.add(Cmb_TskDurLowAnx, null);
    jTextPane1.add(Cmb_TskDurMedAnx, null);
    jTextPane1.add(Cmb_TskQtyLowAnx, null);
    jTextPane1.add(Cmb_TskQtyMedAnx, null);
    jTextPane1.add(Cmb_TskDurLowStrs, null);
    jTextPane1.add(Cmb_TskQtyMedStrs, null);
    jTextPane1.add(Cmb_TskQtyLowStrs, null);
    jTextPane1.add(Cmb_TskDurMedStrs, null);
    jTextPane1.add(Cmb_TskDurHghStrs, null);
    jTextPane1.add(Cmb_TskQtyHghStrs, null);
    jTextPane1.add(jLabel21, null);
    jTextPane1.add(jLabel114, null);
    jTextPane1.add(jLabel113, null);
    jTextPane1.add(jLabel20, null);
    jTextPane1.add(jLabel111, null);
    jTextPane1.add(jLabel112, null);
    jTextPane1.add(jLabel7, null);
    jTextPane1.add(jLabel19, null);
    jTextPane1.add(jLabel110, null);*/
    //contentPane.add(jLabel12, null);
    //contentPane.add(jLabel8, null);
    contentPane.add(Pnl_Trust, null);
    contentPane.add(jLabel9, null);
    //contentPane.add(Chk_TrustModel, null);
    contentPane.add(Txt_Sv, null);
    contentPane.add(But_Assign, null);
    //contentPane.add(But_Defaults, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      this.dispose();
  }

  void But_Assign_mousePressed(MouseEvent e) throws IOException {

    int indexstart;
      try {
           /* BufferedReader In = new BufferedReader(new FileReader("TasksRulesScript.clp"));
            String Rdfile, Reglas = "";

            while ((Rdfile = In.readLine()) != null)
            {
              Reglas = Reglas + Rdfile + "\n";
            }
            In.close();

            String Subs1, Subs2;
            indexstart = Reglas.indexOf("\"tskdurcreatlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurLowCreat.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtycreatlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyLowCreat.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurcreatmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurMedCreat.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtycreatmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyMedCreat.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurcreathgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurHghCreat.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtycreathgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyHghCreat.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurexprnlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurLowExp.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyexprnlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyLowExp.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurexprnmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurMedExp.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyexprnmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyMedExp.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurexprnhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurHghExp.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyexprnhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyHghExp.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurdesirlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurLowDsr.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtydesirlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyLowDsr.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurdesirmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurMedDsr.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtydesirmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyMedDsr.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurdesirhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurHghDsr.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtydesirhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyHghDsr.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurinterlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurLowInt.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyinterlow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyLowInt.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurintermed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurMedInt.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyintermed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyMedInt.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurinterhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurHghInt.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyinterhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyHghInt.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurdisgslow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurLowDis.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtydisgslow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyLowDis.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurdisgsmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurMedDis.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtydisgsmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyMedDis.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurdisgshgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurHghDis.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtydisgshgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyHghDis.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskduranxtylow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurLowAnx.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyanxtylow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyLowAnx.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskduranxtymed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurMedAnx.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyanxtymed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyMedAnx.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskduranxtyhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurHghAnx.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtyanxtyhgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyHghAnx.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurstrsslow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurLowStrs.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtystrsslow\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyLowStrs.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurstrssmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurMedStrs.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtystrssmed\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyMedStrs.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskdurstrsshgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskDurHghStrs.getSelectedItem().toString() + Subs2;
            indexstart = Reglas.indexOf("\"tskqtystrsshgh\"");
            Subs1 = Reglas.substring(0,indexstart+1);
            Subs2 = Reglas.substring(indexstart + 15);
            Reglas = Subs1 + Cmb_TskQtyHghStrs.getSelectedItem().toString() + Subs2;


            FileWriter Out2 = new FileWriter("TasksRules.clp");
            Out2.write(Reglas);
            Out2.close();
            LlenaRelations();
            ObjectOutputStream OutRelations = new ObjectOutputStream(new FileOutputStream("Relations.cfg"));
            OutRelations.writeObject(ObjRelations);
            OutRelations.close();*/
    	  	
            Integer Desv = new Integer(Txt_Sv.getText());
            Sv = Desv.intValue();
            includeTrustModel = Chk_TrustModel.isSelected();
            if (Cmb_TrustLevel.getSelectedIndex() == 0)
            	initialTrustLevel = 0.0;
            else if (Cmb_TrustLevel.getSelectedIndex() == 1)
            	initialTrustLevel = 25.0;
            else if (Cmb_TrustLevel.getSelectedIndex() == 2)
            	initialTrustLevel = 50.0;
            this.dispose();
          }
      catch (Exception exc) { System.out.println(exc); }
  }

  void Carga_Datos(){

   try {
         ObjectInputStream InRelations = new ObjectInputStream(new FileInputStream("Relations.cfg"));
         ObjRelations = (Relations)InRelations.readObject();
         InRelations.close();
        }
     catch ( FileNotFoundException fnfexc ) {
          ObjRelations = new Relations();
          ObjRelations.setDefault();
        }
     catch ( IOException exc ) { System.out.println("ERROR EN CONFIGURE 542" + exc); }
     catch ( ClassNotFoundException e2 ) { System.out.println("ERROR EN CONFIGURE 543" + e2); }

     LlenaCombos();
     Integer Desv = new Integer(Sv);
     Txt_Sv.setText(Desv.toString());
     Chk_TrustModel.setSelected(includeTrustModel);
  }

  void But_Defaults_mousePressed(MouseEvent e) {
      ObjRelations.setDefault();
      LlenaCombos();

  }

  void LlenaCombos(){

    Cmb_TskDurLowCreat.setSelectedItem(ObjRelations.getTskDurLowCreat());
    Cmb_TskDurMedCreat.setSelectedItem(ObjRelations.getTskDurMedCreat());
    Cmb_TskDurHghCreat.setSelectedItem(ObjRelations.getTskDurHghCreat());
    Cmb_TskQtyLowCreat.setSelectedItem(ObjRelations.getTskQtyLowCreat());
    Cmb_TskQtyMedCreat.setSelectedItem(ObjRelations.getTskQtyMedCreat());
    Cmb_TskQtyHghCreat.setSelectedItem(ObjRelations.getTskQtyHghCreat());
    Cmb_TskDurLowExp.setSelectedItem(ObjRelations.getTskDurLowExprn());
    Cmb_TskDurMedExp.setSelectedItem(ObjRelations.getTskDurMedExprn());
    Cmb_TskDurHghExp.setSelectedItem(ObjRelations.getTskDurHghExprn());
    Cmb_TskQtyLowExp.setSelectedItem(ObjRelations.getTskQtyLowExprn());
    Cmb_TskQtyMedExp.setSelectedItem(ObjRelations.getTskQtyMedExprn());
    Cmb_TskQtyHghExp.setSelectedItem(ObjRelations.getTskQtyHghExprn());
    Cmb_TskDurLowDsr.setSelectedItem(ObjRelations.getTskDurLowDesir());
    Cmb_TskDurMedDsr.setSelectedItem(ObjRelations.getTskDurMedDesir());
    Cmb_TskDurHghDsr.setSelectedItem(ObjRelations.getTskDurHghDesir());
    Cmb_TskQtyLowDsr.setSelectedItem(ObjRelations.getTskQtyLowDesir());
    Cmb_TskQtyMedDsr.setSelectedItem(ObjRelations.getTskQtyMedDesir());
    Cmb_TskQtyHghDsr.setSelectedItem(ObjRelations.getTskQtyHghDesir());
    Cmb_TskDurLowInt.setSelectedItem(ObjRelations.getTskDurLowInter());
    Cmb_TskDurMedInt.setSelectedItem(ObjRelations.getTskDurMedInter());
    Cmb_TskDurHghInt.setSelectedItem(ObjRelations.getTskDurHghInter());
    Cmb_TskQtyLowInt.setSelectedItem(ObjRelations.getTskQtyLowInter());
    Cmb_TskQtyMedInt.setSelectedItem(ObjRelations.getTskQtyMedInter());
    Cmb_TskQtyHghInt.setSelectedItem(ObjRelations.getTskQtyHghInter());
    Cmb_TskDurLowDis.setSelectedItem(ObjRelations.getTskDurLowDisgs());
    Cmb_TskDurMedDis.setSelectedItem(ObjRelations.getTskDurMedDisgs());
    Cmb_TskDurHghDis.setSelectedItem(ObjRelations.getTskDurHghDisgs());
    Cmb_TskQtyLowDis.setSelectedItem(ObjRelations.getTskQtyLowDisgs());
    Cmb_TskQtyMedDis.setSelectedItem(ObjRelations.getTskQtyMedDisgs());
    Cmb_TskQtyHghDis.setSelectedItem(ObjRelations.getTskQtyHghDisgs());
    Cmb_TskDurLowAnx.setSelectedItem(ObjRelations.getTskDurLowAnxty());
    Cmb_TskDurMedAnx.setSelectedItem(ObjRelations.getTskDurMedAnxty());
    Cmb_TskDurHghAnx.setSelectedItem(ObjRelations.getTskDurHghAnxty());
    Cmb_TskQtyLowAnx.setSelectedItem(ObjRelations.getTskQtyLowAnxty());
    Cmb_TskQtyMedAnx.setSelectedItem(ObjRelations.getTskQtyMedAnxty());
    Cmb_TskQtyHghAnx.setSelectedItem(ObjRelations.getTskQtyHghAnxty());
    Cmb_TskDurLowStrs.setSelectedItem(ObjRelations.getTskDurLowStrss());
    Cmb_TskDurMedStrs.setSelectedItem(ObjRelations.getTskDurMedStrss());
    Cmb_TskDurHghStrs.setSelectedItem(ObjRelations.getTskDurHghStrss());
    Cmb_TskQtyLowStrs.setSelectedItem(ObjRelations.getTskQtyLowStrss());
    Cmb_TskQtyMedStrs.setSelectedItem(ObjRelations.getTskQtyMedStrss());
    Cmb_TskQtyHghStrs.setSelectedItem(ObjRelations.getTskQtyHghStrss());
  }

  void LlenaRelations(){

     ObjRelations.setTskDurLowCreat(Cmb_TskDurLowCreat.getSelectedItem().toString());
     ObjRelations.setTskDurMedCreat(Cmb_TskDurMedCreat.getSelectedItem().toString());
     ObjRelations.setTskDurHghCreat(Cmb_TskDurHghCreat.getSelectedItem().toString());
     ObjRelations.setTskQtyLowCreat(Cmb_TskQtyLowCreat.getSelectedItem().toString());
     ObjRelations.setTskQtyMedCreat(Cmb_TskQtyMedCreat.getSelectedItem().toString());
     ObjRelations.setTskQtyHghCreat(Cmb_TskQtyHghCreat.getSelectedItem().toString());
     ObjRelations.setTskDurLowExprn(Cmb_TskDurLowExp.getSelectedItem().toString());
     ObjRelations.setTskDurMedExprn(Cmb_TskDurMedExp.getSelectedItem().toString());
     ObjRelations.setTskDurHghExprn(Cmb_TskDurHghExp.getSelectedItem().toString());
     ObjRelations.setTskQtyLowExprn(Cmb_TskQtyLowExp.getSelectedItem().toString());
     ObjRelations.setTskQtyMedExprn(Cmb_TskQtyMedExp.getSelectedItem().toString());
     ObjRelations.setTskQtyHghExprn(Cmb_TskQtyHghExp.getSelectedItem().toString());
     ObjRelations.setTskDurLowDesir(Cmb_TskDurLowDsr.getSelectedItem().toString());
     ObjRelations.setTskDurMedDesir(Cmb_TskDurMedDsr.getSelectedItem().toString());
     ObjRelations.setTskDurHghDesir(Cmb_TskDurHghDsr.getSelectedItem().toString());
     ObjRelations.setTskQtyLowDesir(Cmb_TskQtyLowDsr.getSelectedItem().toString());
     ObjRelations.setTskQtyMedDesir(Cmb_TskQtyMedDsr.getSelectedItem().toString());
     ObjRelations.setTskQtyHghDesir(Cmb_TskQtyHghDsr.getSelectedItem().toString());
     ObjRelations.setTskDurLowInter(Cmb_TskDurLowInt.getSelectedItem().toString());
     ObjRelations.setTskDurMedInter(Cmb_TskDurMedInt.getSelectedItem().toString());
     ObjRelations.setTskDurHghInter(Cmb_TskDurHghInt.getSelectedItem().toString());
     ObjRelations.setTskQtyLowInter(Cmb_TskQtyLowInt.getSelectedItem().toString());
     ObjRelations.setTskQtyMedInter(Cmb_TskQtyMedInt.getSelectedItem().toString());
     ObjRelations.setTskQtyHghInter(Cmb_TskQtyHghInt.getSelectedItem().toString());
     ObjRelations.setTskDurLowDisgs(Cmb_TskDurLowDis.getSelectedItem().toString());
     ObjRelations.setTskDurMedDisgs(Cmb_TskDurMedDis.getSelectedItem().toString());
     ObjRelations.setTskDurHghDisgs(Cmb_TskDurHghDis.getSelectedItem().toString());
     ObjRelations.setTskQtyLowDisgs(Cmb_TskQtyLowDis.getSelectedItem().toString());
     ObjRelations.setTskQtyMedDisgs(Cmb_TskQtyMedDis.getSelectedItem().toString());
     ObjRelations.setTskQtyHghDisgs(Cmb_TskQtyHghDis.getSelectedItem().toString());
     ObjRelations.setTskDurLowAnxty(Cmb_TskDurLowAnx.getSelectedItem().toString());
     ObjRelations.setTskDurMedAnxty(Cmb_TskDurMedAnx.getSelectedItem().toString());
     ObjRelations.setTskDurHghAnxty(Cmb_TskDurHghAnx.getSelectedItem().toString());
     ObjRelations.setTskQtyLowAnxty(Cmb_TskQtyLowAnx.getSelectedItem().toString());
     ObjRelations.setTskQtyMedAnxty(Cmb_TskQtyMedAnx.getSelectedItem().toString());
     ObjRelations.setTskQtyHghAnxty(Cmb_TskQtyHghAnx.getSelectedItem().toString());
     ObjRelations.setTskDurLowStrss(Cmb_TskDurLowStrs.getSelectedItem().toString());
     ObjRelations.setTskDurMedStrss(Cmb_TskDurMedStrs.getSelectedItem().toString());
     ObjRelations.setTskDurHghStrss(Cmb_TskDurHghStrs.getSelectedItem().toString());
     ObjRelations.setTskQtyLowStrss(Cmb_TskQtyLowStrs.getSelectedItem().toString());
     ObjRelations.setTskQtyMedStrss(Cmb_TskQtyMedStrs.getSelectedItem().toString());
     ObjRelations.setTskQtyHghStrss(Cmb_TskQtyHghStrs.getSelectedItem().toString());

  }

}