/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the main agent that act as interface with the users.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import javax.swing.UIManager;
import java.awt.*;

import jade.core.Runtime;
import jade.core.Profile;
import jade.core.ProfileImpl;
import jade.wrapper.*;
import jade.wrapper.AgentContainer;
import jade.core.Agent;
import jade.core.AID;


public class Interfaz extends Agent{
  boolean packFrame = false;
 // public static PlatformController Container;

  /**Construct the application*/
  public Interfaz() {
    System.out.println("");
    System.out.println("");
    System.out.println("*********************************************");
    System.out.println("This is Multi-Agent System to Simulate Human");
    System.out.println("Behaviour within a Work Team.");
    System.out.println("version 2.0.0");
    System.out.println("");
    System.out.println("@author: Juan C. Martinez Miranda.");
    System.out.println("         juan.martinez.miranda@gmail.com");
    System.out.println("Institution: Universidad Complutense de Madrid");
    System.out.println("             Facultad de Informtica");
    System.out.println("WINTER 2010");
    System.out.println("*********************************************");
    System.out.println("");
    System.out.println("");
    //AgentContainer cc = getContainerController();
    //Principal frame = new Principal();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    /*if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);*/
  }
  
  protected void setup() {
	  
	  AgentContainer cc = getContainerController();
	  Principal frame = new Principal(cc);
	  
	  if (packFrame) {
	      frame.pack();
	    }
	    else {
	      frame.validate();
	    }
	    //Center the window
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	    Dimension frameSize = frame.getSize();
	    if (frameSize.height > screenSize.height) {
	      frameSize.height = screenSize.height;
	    }
	    if (frameSize.width > screenSize.width) {
	      frameSize.width = screenSize.width;
	    }
	    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
	    frame.setVisible(true);
  }
  
  
  /**Main method*/
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
     new Interfaz();
  }

}