/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class for showing the results of the simulations.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class Progress extends JFrame {

  JPanel contentPane;
  JProgressBar Prg_Progreso = new JProgressBar();
  public static JLabel Lbl_Progreso = new JLabel();
  public static JLabel Lbl_Numero = new JLabel();
  Cursor Normal = new Cursor(0);
  Cursor Reloj = new Cursor(3);

  /**Construct the frame*/
  public Progress() {
    setCursor(Reloj);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
   try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Principal.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    this.setResizable(false);
    this.setSize(new Dimension(333, 130));
    this.setTitle("Executing simulations....");
    contentPane.setPreferredSize(new Dimension(1, 1));
    Prg_Progreso.setStringPainted(true);
    Prg_Progreso.setBounds(new Rectangle(13, 40, 298, 27));
    Lbl_Progreso.setFont(new java.awt.Font("Dialog", 1, 12));
    Lbl_Progreso.setBounds(new Rectangle(6, 5, 313, 24));
    Lbl_Numero.setBounds(new Rectangle(12, 71, 299, 24));
    Lbl_Numero.setFont(new java.awt.Font("Dialog", 1, 12));
    Lbl_Numero.setHorizontalAlignment(SwingConstants.CENTER);
    Lbl_Numero.setHorizontalTextPosition(SwingConstants.CENTER);
    Lbl_Numero.setText("Simulation Number:");
    contentPane.add(Lbl_Progreso, null);
    contentPane.add(Prg_Progreso, null);
    contentPane.add(Lbl_Numero, null);
  }


  public void Incrementa(int valor){

    if (valor != 100)
      { if ((Prg_Progreso.getValue() + valor) >= 100)
          Prg_Progreso.setValue(98);
        else
          Prg_Progreso.setValue(Prg_Progreso.getValue() + valor);
      }
    else
      Prg_Progreso.setValue(Prg_Progreso.getValue() + valor);

   if (Prg_Progreso.getValue() >= 100)
     { this.dispose();
       setCursor(Normal);
     }
  }

}